/*
 * 93Cxx.c
 *
 *  Created on: 09.01.2013
 *      Author: helmo
 */

#include "spi.h"
#include "stdint.h"
#include <util/delay.h>


#define CMD_READ   0x06
#define CMD_EWEN   0x04
#define CMD_ERASE  0x07
#define CMD_WRITE  0x05
#define CMD_ERAL   0x04
#define CMD_WRAL   0x04
#define CMD_EWDS   0x04

#define ADD_EWEN(_width_)   (0x03 << (_width_ - 2))
#define ADD_ERAL(_width_)   (0x02 << (_width_ - 2))
#define ADD_WRAL(_width_)   (0x01 << (_width_ - 2))
#define ADD_EWDS(_width_)   (0x00 << (_width_ - 2))



uint16_t eeprom_read_add6_bit(uint8_t addr)
{
	uint16_t retval;
	CS_HIGH();
	spi_send(CMD_READ, 3);
	spi_send(addr, 6);
	retval = spi_send(0x00, 8);
	retval = retval << 8;
	retval |= spi_send(0x00, 8);
	CS_LOW();
	return retval;
}


void eeprom_write_add_6bit(uint8_t addr, uint16_t data)
{
	CS_HIGH();

	spi_send(CMD_EWEN, 3);
	spi_send(ADD_EWEN(6), 6);

	CS_LOW();
	_delay_us(1);
	CS_HIGH();

	spi_send(CMD_ERASE, 3);
	spi_send(addr, 6);

	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);
	while(BUSY());
	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);

	spi_send(CMD_WRITE, 3);
	spi_send(addr, 6);
	spi_send(data >> 8, 8);
	spi_send(data >> 0, 8);

	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);
	while(BUSY());
	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);

	spi_send(CMD_EWDS, 3);
	spi_send(ADD_EWDS(6), 6);
	CS_LOW();
}



uint16_t eeprom_read_add8_bit(uint8_t addr)
{
	uint16_t retval;
	CS_HIGH();
	spi_send(CMD_READ, 3);
	spi_send(addr, 8);
	retval = spi_send(0x00, 8);
	retval = retval << 8;
	retval |= spi_send(0x00, 8);
	CS_LOW();
	return retval;
}


void eeprom_write_add_8bit(uint8_t addr, uint16_t data)
{
	CS_HIGH();

	spi_send(CMD_EWEN, 3);
	spi_send(ADD_EWEN(8), 8);

	CS_LOW();
	_delay_us(1);
	CS_HIGH();

	spi_send(CMD_ERASE, 3);
	spi_send(addr, 8);

	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);
	while(BUSY());
	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);

	spi_send(CMD_WRITE, 3);
	spi_send(addr, 8);
	spi_send(data >> 8, 8);
	spi_send(data >> 0, 8);

	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);
	while(BUSY());
	CS_LOW();
	_delay_us(1);
	CS_HIGH();
	_delay_us(1);

	spi_send(CMD_EWDS, 3);
	spi_send(ADD_EWDS(8), 8);
	CS_LOW();
}
