#include "spi.h"
#include <util/delay.h>

#define SCK_HIGH()   SPI_PORT |=  (1 << SCK)
#define SCK_LOW()    SPI_PORT &= ~(1 << SCK)

#define MOSI_HIGH()  SPI_PORT |=  (1 << MOSI)
#define MOSI_LOW()   SPI_PORT &= ~(1 << MOSI)



void spi_init(void)
{
	SPI_DIR  |=  (1 << MOSI) | (1 << SCK) | (1 << CS);	// Configure IO-Pins
	SPI_DIR  &= ~(1 << MISO);
	SPI_PORT |=  (1 << MISO); // enable Pullup;
	CS_HIGH();
	SCK_LOW();
}


uint8_t spi_send(uint8_t data, uint8_t anz)
{
	uint8_t retval = 0;
	uint8_t i;

	uint8_t mask = (1 << (anz - 1));


	_delay_us(0.5);

	for (i=0; i < anz; i++) {
		retval = retval << 1;
		if (data & mask) {
			MOSI_HIGH();
		} else {
			MOSI_LOW();
		}
		_delay_us(0.5);
		SCK_HIGH();
		_delay_us(0.5);
		retval |= MISO_STATE();
		SCK_LOW();
		data = (data << 1);
	}
	_delay_us(3);
	return retval;

};
