#ifndef __SPI_H__
#define __SPI_H__

#include <avr/io.h>

#define SPI_PORT	PORTB
#define SPI_DIR		DDRB
#define SPI_PIN		PINB

#define MISO		PB4
#define MOSI		PB3
#define SCK			PB5
#define CS			PB2


#define CS_HIGH()	 SPI_PORT |=  (1 << CS)
#define CS_LOW()	 SPI_PORT &= ~(1 << CS)

#define MISO_STATE()   ((SPI_PIN & (1 << MISO)) != 0)


#define BUSY() (MISO_STATE() == 0)

void spi_init(void);
uint8_t spi_send(uint8_t data, uint8_t anz);

#endif // __SPI_H__
